-- by modelleicher
-- www.schwabenmodding.bplaced.net
-- ZugmaulVisibilityV2
-- Sorgt dafr dass das Zugmaul ausgeblendet und der Oberlenker eingeblendet wird sobald man ein Gert attacht.
-- V2 aenderungen, Man kann ackerschieneIndex, zugmaulIndex und auch oberlenkerIndex in der xml weglassen und das Script funktioniert dennoch. 
--                Fuer alle Mods die keine Ackerschiene oder ein festes Zugmaul haben, oder nur die Ackerschiene ausgeblendet werden muss.

ZugmaulVisibilityV2 = {};

function ZugmaulVisibilityV2.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Motorized, specializations);
end;

function ZugmaulVisibilityV2:load(xmlFile)
	self.setZvState = ZugmaulVisibilityV2.setZvState;
	self.setZvFState = ZugmaulVisibilityV2.setZvFState;
	self.setFLState = ZugmaulVisibilityV2.setFLState;

    self.oberlenkerFIndex = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.ZugmaulVisible#oberlenkerFIndex"));
	self.oberlenkerIndex = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.ZugmaulVisible#oberlenkerIndex"));
	self.ackerschieneIndex = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.ZugmaulVisible#ackerschieneIndex"));
	self.konzoleIndex = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.ZugmaulVisible#konzoleIndex"));

	self:setZvState(0);
	self:setZvFState(0);
	self:setFLState(0);
end;
function ZugmaulVisibilityV2:delete()
end;
function ZugmaulVisibilityV2:mouseEvent(posX, posY, isDown, isUp, button)
end;
function ZugmaulVisibilityV2:keyEvent(unicode, sym, modifier, isDown)   
end;
function ZugmaulVisibilityV2:attachImplement(implement)
	local attacherIndex = implement.jointDescIndex;
	if attacherIndex == 1 then
		self:setZvState(1);
	end;
	if attacherIndex == 2 then
		self:setZvFState(1);
	end;
	if attacherIndex == 3 then
		self:setFLState(1);
	end;
end;
function ZugmaulVisibilityV2:detachImplement(implementIndex)
	local implement = self.attachedImplements[implementIndex];
	local attacherIndex = implement.jointDescIndex;
    if attacherIndex == 1 then
		self:setZvState(0)
	end;
	if attacherIndex == 2 then
		self:setZvFState(0)
	end;
	if attacherIndex == 3 then
		self:setFLState(0)
	end;
end;
function ZugmaulVisibilityV2:setZvState(currentState)
	if currentState == 0 then
		if self.oberlenkerIndex ~= nil then
		setVisibility(self.oberlenkerIndex, false);
		end;
	elseif currentState == 1 then
		if self.oberlenkerIndex ~= nil then
		setVisibility(self.oberlenkerIndex, true);
		end;
	end;
end;
function ZugmaulVisibilityV2:setZvFState(currentState)
	if currentState == 0 then
		if self.oberlenkerFIndex ~= nil then
		setVisibility(self.oberlenkerFIndex, false);
		end;
	elseif currentState == 1 then
		if self.oberlenkerFIndex ~= nil then
		setVisibility(self.oberlenkerFIndex, true);
		end;
	end;
end;
function ZugmaulVisibilityV2:setFLState(currentState)
	if currentState == 0 then
		if self.konzoleIndex ~= nil then
		setVisibility(self.konzoleIndex, false);
		end;
	elseif currentState == 1 then
		if self.konzoleIndex ~= nil then
		setVisibility(self.konzoleIndex, true);
		end;
	end;
end;

function ZugmaulVisibilityV2:update(dt)

end;
function ZugmaulVisibilityV2:draw()
end;
function ZugmaulVisibilityV2:onLeave()
end;
